
if version < 600
    syntax clear
elseif exists ("b:current_syntax")
    finish
endif

syn case ignore
syn keyword CfgOnOff  ON OFF YES NO TRUE FALSE  contained
syn match UncPath "\\\\\p*" contained
syn match CfgDirectory "[a-zA-Z]:\\\p*" contained
syn match   CfgParams    ".*="me=e-1 contains=CfgComment
syn match   CfgValues    "=.*"hs=s+1 contains=CfgDirectory,UncPath,CfgComment,CfgString,CfgOnOff

syn match CfgSection	    "\[.*\]"
syn match CfgSection	    "{.*}"

syn match  CfgString	"\".*\"" contained
syn match  CfgString    "'.*'"   contained

syn match  CfgComment	"#.*"
syn match  CfgComment	";.*"
syn match  CfgComment	"\/\/.*"

if version >= 508 || !exists("did_cfg_syn_inits")
    if version < 508
	let did_cfg_syn_inits = 1
	command -nargs=+ HiLink hi link <args>
    else
	command -nargs=+ HiLink hi def link <args>
    endif
    HiLink CfgOnOff     Label
    HiLink CfgComment	Comment
    HiLink CfgSection	Type
    HiLink CfgString	String
    HiLink CfgParams    Keyword
    HiLink CfgValues    Constant
    HiLink CfgDirectory Directory
    HiLink UncPath      Directory

    delcommand HiLink
endif
let b:current_syntax = "cfg"
