
if exists("b:current_syntax")
  finish
endif

syn keyword dExternal		import package module extern
syn keyword dConditional	if else switch iftype
syn keyword dBranch		goto break continue
syn keyword dRepeat		while for do foreach
syn keyword dBoolean		true false
syn keyword dConstant		null
syn keyword dConstant		__FILE__ __LINE__ __DATE__ __TIME__ __TIMESTAMP__
syn keyword dTypedef		alias typedef
syn keyword dStructure		template interface class enum struct union
syn keyword dOperator		new delete typeof typeid cast align is
syn keyword dOperator		this super
if exists("d_hl_operator_overload")
  syn keyword dOpOverload	opNeg opCom opPostInc opPostDec opCast opAdd opSub opSub_r
  syn keyword dOpOverload	opMul opDiv opDiv_r opMod opMod_r opAnd opOr opXor
  syn keyword dOpOverload	opShl opShl_r opShr opShr_r opUShr opUShr_r opCat
  syn keyword dOpOverload	opCat_r opEquals opEquals opCmp opCmp opCmp opCmp
  syn keyword dOpOverload	opAddAssign opSubAssign opMulAssign opDivAssign
  syn keyword dOpOverload	opModAssign opAndAssign opOrAssign opXorAssign
  syn keyword dOpOverload	opShlAssign opShrAssign opUShrAssign opCatAssign
  syn keyword dOpOverload	opIndex opIndexAssign opCall opSlice opSliceAssign opPos
  syn keyword dOpOverload	opAdd_r opMul_r opAnd_r opOr_r opXor_r 
endif
syn keyword dType		ushort int uint long ulong float
syn keyword dType		void byte ubyte double bit char wchar ucent cent
syn keyword dType		short bool dchar
syn keyword dType		real ireal ifloat idouble creal cfloat cdouble
syn keyword dDebug		deprecated unittest
syn keyword dExceptions		throw try catch finally
syn keyword dScopeDecl		public protected private export
syn keyword dStatement		version debug return with invariant body scope
syn keyword dStatement		in out inout asm mixin
syn keyword dStatement		function delegate
syn keyword dStorageClass	auto static override final const abstract volatile
syn keyword dStorageClass	synchronized
syn keyword dPragma		pragma


syn match dAssert "^assert\>"
syn match dAssert "[^.]\s*\<assert\>"ms=s+1


syn match dUserLabel	"^\s*[_$a-zA-Z][_$a-zA-Z0-9_]*\s*:"he=e-1 contains=dLabel,dScopeDecl
syn keyword dLabel	case default

syn keyword dTodo	contained TODO FIXME TEMP XXX
syn match dCommentStar	contained "^\s*\*[^/]"me=e-1
syn match dCommentStar	contained "^\s*\*$"
syn match dCommentPlus	contained "^\s*+[^/]"me=e-1
syn match dCommentPlus	contained "^\s*+$"
if exists("d_comment_strings")
  syn region dBlockCommentString	contained start=+"+ end=+"+ end=+\*/+me=s-1,he=s-1 contains=dCommentStar,dUnicode,dEscSequence,@Spell
  syn region dNestedCommentString	contained start=+"+ end=+"+ end="+"me=s-1,he=s-1 contains=dCommentPlus,dUnicode,dEscSequence,@Spell
  syn region dLineCommentString		contained start=+"+ end=+$\|"+ contains=dUnicode,dEscSequence,@Spell
  syn region dBlockComment	start="/\*"  end="\*/" contains=dBlockCommentString,dTodo,@Spell
  syn region dNestedComment	start="/+"  end="+/" contains=dNestedComment,dNestedCommentString,dTodo,@Spell
  syn match  dLineComment	"//.*" contains=dLineCommentString,dTodo,@Spell
else
  syn region dBlockComment	start="/\*"  end="\*/" contains=dBlockCommentString,dTodo,@Spell
  syn region dNestedComment	start="/+"  end="+/" contains=dNestedComment,dNestedCommentString,dTodo,@Spell
  syn match  dLineComment	"//.*" contains=dLineCommentString,dTodo,@Spell
endif

hi link dLineCommentString	dBlockCommentString
hi link dBlockCommentString	dString
hi link dNestedCommentString	dString
hi link dCommentStar		dBlockComment
hi link dCommentPlus		dNestedComment

syn sync minlines=200
syn sync ccomment dBlockComment

syn match dSpecialCharError contained "[^']"

syn match dEscSequence	"\\\(\o\{1,3}\|[\"\\'\\?ntbrfva]\|u\x\{4}\|U\x\{8}\|x\x\x\)"
syn match dEscSequence "\\&[^;& \t]\+;"
syn match dCharacter	"'[^']*'" contains=dEscSequence,dSpecialCharError
syn match dCharacter	"'\\''" contains=dEscSequence
syn match dCharacter	"'[^\\]'"

syn match dUnicode "\\u\d\{4\}"


syn region dString	start=+"+ end=+"[cwd]\=+ contains=dEscSequence,@Spell
syn region dRawString	start=+`+ skip=+\\`+ end=+`[cwd]\=+ contains=@Spell
syn region dRawString	start=+r"+ skip=+\\"+ end=+"[cwd]\=+ contains=@Spell
syn region dHexString	start=+x"+ skip=+\\"+ end=+"[cwd]\=+ contains=@Spell

syn case ignore

syn match dDec		display "\<\d[0-9_]*\(u\=l\=\|l\=u\=\)\>"

syn match dHex		display "\<0x[0-9a-f_]\+\(u\=l\=\|l\=u\=\)\>"

syn match dOctal	display "\<0[0-7_]\+\(u\=l\=\|l\=u\=\)\>"
syn match dOctalError	display "\<0[0-7_]*[89][0-9_]*"

syn match dBinary	display "\<0b[01_]\+\(u\=l\=\|l\=u\=\)\>"

syn match dFloat	display "\<\d[0-9_]*\(fi\=\|l\=i\)\>"
syn match dFloat	display "\<\d[0-9_]*\.[0-9_]*\(e[-+]\=[0-9_]\+\)\=[fl]\=i\="
syn match dFloat	display "\(\.[0-9_]\+\)\(e[-+]\=[0-9_]\+\)\=[fl]\=i\=\>"
syn match dFloat	display "\<\d[0-9_]*e[-+]\=[0-9_]\+[fl]\=\>"

syn match dHexFloat	display "\<0x[0-9a-f_]\+\(fi\=\|l\=i\)\>"
syn match dHexFloat	display "\<0x[0-9a-f_]\+\.[0-9a-f_]*\(p[-+]\=[0-9_]\+\)\=[fl]\=i\="
syn match dHexFloat	display "\<0x[0-9a-f_]\+p[-+]\=[0-9_]\+[fl]\=i\=\>"

syn case match

syn region  dPragma start="#\s*\(line\>\)" skip="\\$" end="$"


hi def link dBinary		Number
hi def link dDec		Number
hi def link dHex		Number
hi def link dOctal		Number
hi def link dFloat		Float
hi def link dHexFloat		Float
hi def link dDebug		Debug
hi def link dBranch		Conditional
hi def link dConditional	Conditional
hi def link dLabel		Label
hi def link dUserLabel		Label
hi def link dRepeat		Repeat
hi def link dExceptions		Exception
hi def link dAssert		Statement
hi def link dStatement		Statement
hi def link dScopeDecl		dStorageClass
hi def link dStorageClass	StorageClass
hi def link dBoolean		Boolean
hi def link dUnicode		Special
hi def link dRawString		String
hi def link dString		String
hi def link dHexString		String
hi def link dCharacter		Character
hi def link dEscSequence	SpecialChar
hi def link dSpecialCharError	Error
hi def link dOctalError		Error
hi def link dOperator		Operator
hi def link dOpOverload		Operator
hi def link dConstant		Constant
hi def link dTypedef		Typedef
hi def link dStructure		Structure
hi def link dTodo		Todo
hi def link dType		Type
hi def link dLineComment	Comment
hi def link dBlockComment	Comment
hi def link dNestedComment	Comment
hi def link dExternal		Include
hi def link dPragma		PreProc

let b:current_syntax = "d"
   
