
if version < 600
	syntax clear
elseif exists("b:current_syntax")
	finish
endif

syn case ignore

syn region elfEnvironment transparent matchgroup=Special start="{" matchgroup=Special end="}" contains=ALLBUT,elfBraceError

syn match elfBraceError "}"

syn keyword elfSpecial endmacro
syn region elfSpecial transparent matchgroup=Special start="^\(\(macro\)\|\(set\)\) \S\+$" matchgroup=Special end="^\(\(endmacro\)\|\(endset\)\)$" contains=ALLBUT,elfBraceError

syn keyword elfPPCom define include

syn keyword elfKeyword  false true null
syn keyword elfKeyword	var format object function endfunction

syn keyword elfConditional if else case of endcase for to next while until return goto

syn match elfMacro "[0-9_A-Za-z]\+@"

syn region elfString start=+"+  skip=+\\\\\|\\"+  end=+"+

syn match elfNumber "-\=\<[0-9]*\.\=[0-9_]\>"

syn region elfComment start="/\*"  end="\*/"
syn match elfComment  "\'.*$"

syn sync ccomment elfComment

syn match elfParens "[\[\]()]"

syn match elfPunct "[,;]"

if version >= 508 || !exists("did_elf_syn_inits")
	if version < 508
		let did_elf_syn_inits = 1
		command -nargs=+ HiLink hi link <args>
	else
		command -nargs=+ HiLink hi def link <args>
   endif

  " The default methods for highlighting. Can be overridden later.
  HiLink elfComment Comment
  HiLink elfPPCom Include
  HiLink elfKeyword Keyword
  HiLink elfSpecial Special
  HiLink elfEnvironment Special
  HiLink elfBraceError Error
  HiLink elfConditional Conditional
  HiLink elfMacro Function
  HiLink elfNumber Number
  HiLink elfString String
  HiLink elfParens Delimiter
  HiLink elfPunct Delimiter

  delcommand HiLink
endif

let b:current_syntax = "elf"

