
if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

syn case ignore

syn match registryHead		"^REGEDIT[0-9]*$"

syn match  registryComment	"^;.*$"

syn keyword registryHKEY	HKEY_LOCAL_MACHINE HKEY_CLASSES_ROOT HKEY_CURRENT_USER
syn keyword registryHKEY	HKEY_USERS HKEY_CURRENT_CONFIG HKEY_DYN_DATA
syn keyword registryHKEY	HKLM HKCR HKCU HKU HKCC HKDD

syn match   registryGUID	"{[0-9A-Fa-f]\{8}\-[0-9A-Fa-f]\{4}\-[0-9A-Fa-f]\{4}\-[0-9A-Fa-f]\{4}\-[0-9A-Fa-f]\{12}}" contains=registrySpecial


syn match   registrySpecial	"\\"
syn match   registrySpecial	"\\\\"
syn match   registrySpecial	"\\\""
syn match   registrySpecial	"\."
syn match   registrySpecial	","
syn match   registrySpecial	"\/"
syn match   registrySpecial	":"
syn match   registrySpecial	"-"

syn match   registryString	"\".*\"" contains=registryGUID,registrySpecial

syn region  registryPath		start="\[" end="\]" contains=registryHKEY,registryGUID,registrySpecial

syn region registryRemove	start="\[\-" end="\]" contains=registryHKEY,registryGUID,registrySpecial

syn match  registrySubKey		"^\".*\"="
syn match  registrySubKey		"^\@="


syn match registryHex		"hex\(([0-9]\{0,2})\)\=:\([0-9a-fA-F]\{2},\)*\([0-9a-fA-F]\{2}\|\\\)$" contains=registrySpecial
syn match registryHex		"^\s*\([0-9a-fA-F]\{2},\)\{0,999}\([0-9a-fA-F]\{2}\|\\\)$" contains=registrySpecial
syn match registryDword		"dword:[0-9a-fA-F]\{8}$" contains=registrySpecial

if version >= 508 || !exists("did_registry_syntax_inits")
  if version < 508
    let did_registry_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

   HiLink registryComment	Comment
   HiLink registryHead		Constant
   HiLink registryHKEY		Constant
   HiLink registryPath		Special
   HiLink registryRemove	PreProc
   HiLink registryGUID		Identifier
   HiLink registrySpecial	Special
   HiLink registrySubKey	Type
   HiLink registryString	String
   HiLink registryHex		Number
   HiLink registryDword		Number

   delcommand HiLink
endif


let b:current_syntax = "registry"

