
if version < 600
    syntax clear
elseif exists("b:current_syntax")
    finish
endif


syn case ignore

syn match  robotsComment	"#.*$" contains=robotsUrl,robotsMail,robotsString

syn match  robotsStar		"\*"

syn match  robotsDelimiter	":"


syn match  robotsAgent		"^[Uu][Ss][Ee][Rr]\-[Aa][Gg][Ee][Nn][Tt]"
syn match  robotsDisallow	"^[Dd][Ii][Ss][Aa][Ll][Ll][Oo][Ww]"

synt match robotsLine		"\(^[Uu][Ss][Ee][Rr]\-[Aa][Gg][Ee][Nn][Tt]\|^[Dd][Ii][Ss][Aa][Ll][Ll][Oo][Ww]\):[^#]*"	contains=robotsAgent,robotsDisallow,robotsStar,robotsDelimiter

syn match  robotsUrl		"http[s]\=://\S*"
syn match  robotsMail		"\S*@\S*"
syn region robotsString		start=+L\="+ skip=+\\\\\|\\"+ end=+"+

if version >= 508 || !exists("did_robos_syntax_inits")
  if version < 508
    let did_robots_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

  HiLink robotsComment		Comment
  HiLink robotsAgent		Type
  HiLink robotsDisallow		Statement
  HiLink robotsLine		Special
  HiLink robotsStar		Operator
  HiLink robotsDelimiter	Delimiter
  HiLink robotsUrl		String
  HiLink robotsMail		String
  HiLink robotsString		String

  delcommand HiLink
endif


let b:current_syntax = "robots"


