

if version < 600
  syntax clear
elseif exists("b:current_syntax")
  finish
endif

syn case match

syn match rtfControlWord	"\\[a-z]\+[\-]\=[0-9]*"

syn match rtfNewControlWord	"\\\*\\[a-z]\+[\-]\=[0-9]*"

syn match rtfControlSymbol	"\\[^a-zA-Z\*\{\}\\']"

syn match rtfCharacter		"\\\\"
syn match rtfCharacter		"\\{"
syn match rtfCharacter		"\\}"
syn match rtfCharacter		"\\'[A-Za-z0-9][A-Za-z0-9]"
syn match rtfUnicodeCharacter	"\\u[0-9][0-9]*"

syn match rtfRed		"\\red[0-9][0-9]*"
syn match rtfGreen		"\\green[0-9][0-9]*"
syn match rtfBlue		"\\blue[0-9][0-9]*"

syn match rtfFootNote "[#$K+]{\\footnote.*}" contains=rtfControlWord,rtfNewControlWord

if version >= 508 || !exists("did_rtf_syntax_inits")
  if version < 508
    let did_rtf_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif


   HiLink rtfControlWord		Statement
   HiLink rtfNewControlWord	Special
   HiLink rtfControlSymbol	Constant
   HiLink rtfCharacter		Character
   HiLink rtfUnicodeCharacter	SpecialChar
   HiLink rtfFootNote		Comment

   " Define colors for the syntax file
   hi rtfRed	      term=underline cterm=underline ctermfg=DarkRed gui=underline guifg=DarkRed
   hi rtfGreen	      term=underline cterm=underline ctermfg=DarkGreen gui=underline guifg=DarkGreen
   hi rtfBlue	      term=underline cterm=underline ctermfg=DarkBlue gui=underline guifg=DarkBlue

   HiLink rtfRed	rtfRed
   HiLink rtfGreen	rtfGreen
   HiLink rtfBlue	rtfBlue

  delcommand HiLink
endif


let b:current_syntax = "rtf"

